import 'dart:convert';

import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:wakatime_api/models/aggregated_data_range.dart';
import 'package:wakatime_api/utils/num_converter.dart';

part 'aggregated_data.freezed.dart';
part 'aggregated_data.g.dart';

@freezed
class AggregatedData with _$AggregatedData {
  const factory AggregatedData({
    @JsonKey(name: 'total_seconds') required num totalSeconds,
    @JsonKey(name: 'is_up_to_date') required bool isUpToDate,
    @NumConverter() required num decimal,
    required AggregatedDataRange range,
    required String digital,
    required String text,
    required int timeout,
  }) = _AggregatedData;

  factory AggregatedData.fromJson(Map<String, dynamic> json) =>
      _$AggregatedDataFromJson(json);
}
