import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

part 'aggregated_data_range.freezed.dart';
part 'aggregated_data_range.g.dart';

@freezed
class AggregatedDataRange with _$AggregatedDataRange {
  const factory AggregatedDataRange({
    @JsonKey(name: 'end_date') required DateTime endDate,
    @JsonKey(name: 'end_text') required String endText,
    @JsonKey(name: 'start_date') required DateTime startDate,
    @JsonKey(name: 'start_text') required String startText,
    required DateTime end,
    required DateTime start,
    required String timezone,
  }) = _AggregatedDataRange;

  factory AggregatedDataRange.fromJson(Map<String, dynamic> json) =>
      _$AggregatedDataRangeFromJson(json);
}
