import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

part 'heartbeat.freezed.dart';
part 'heartbeat.g.dart';

@Freezed()
class Heartbeat with _$Heartbeat {
  const factory Heartbeat({
    @JsonKey(name: 'created_at') required String createdAt,
    @JsonKey(name: 'is_write') bool? isWrite,
    @JsonKey(name: 'machine_name_id') required String machineNameId,
    @JsonKey(name: 'user_agent_id') required String userAgentId,
    @JsonKey(name: 'user_id') required String userId,
    required String category,
    required List<String> dependencies,
    required String entity,
    required String id,
    required int lines,
    required double time,
    required String type,
    String? branch,
    int? cursorpos,
    String? language,
    int? lineno,
    String? project,
  }) = _Heartbeat;

  factory Heartbeat.fromJson(Map<String, dynamic> json) =>
      _$HeartbeatFromJson(json);
}
