import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:wakatime_api/models/repository.dart';
part 'project.freezed.dart';

part 'project.g.dart';

@freezed
class Project with _$Project {
  const factory Project({
    @JsonKey(name: 'has_public_url', defaultValue: false)
    @Default(false)
        bool hasPublicUrl,
    @JsonKey(name: 'last_heartbeat_at') required DateTime lastHeartbeatAt,
    @JsonKey(name: 'urlencoded_name') String? urlEncodedName,
    required String id,
    required String name,
    Repository? repository,
    String? url,
  }) = _Project;

  factory Project.fromJson(Map<String, dynamic> json) =>
      _$ProjectFromJson(json);
}
