import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
import 'package:wakatime_api/models/duration_mixin.dart';

part 'project_heartbeat_duration.freezed.dart';
part 'project_heartbeat_duration.g.dart';

@freezed
class ProjectHeartbeatDuration
    with _$ProjectHeartbeatDuration, HeartbeatDuration {
  const factory ProjectHeartbeatDuration({
    required String branch,
    required String language,
    required String project,
    required String type,
    required num time,
    required num duration,
    String? entity,
  }) = _ProjectHeartbeatDuration;

  factory ProjectHeartbeatDuration.fromJson(Map<String, dynamic> json) =>
      _$ProjectHeartbeatDurationFromJson(json);
}
