import 'package:flutter/foundation.dart';
import 'package:freezed_annotation/freezed_annotation.dart';
part 'repository.freezed.dart';

part 'repository.g.dart';

@freezed
class Repository with _$Repository {
  const factory Repository({
    @JsonKey(name: 'created_at') required DateTime createdAt,
    @JsonKey(name: 'default_branch') required String defaultBranch,
    @JsonKey(name: 'fork_count') required int forkCount,
    @JsonKey(name: 'description') String? description,
    @JsonKey(name: 'full_name') required String fullName,
    @JsonKey(name: 'is_private') required bool isPrivate,
    @JsonKey(name: 'star_count') required int starCount,
    @JsonKey(name: 'watch_count') required int watchCount,
    required String id,
    required String name,
    required String provider,
  }) = _Repository;

  factory Repository.fromJson(Map<String, dynamic> json) =>
      _$RepositoryFromJson(json);
}
