import 'package:flutter_test/flutter_test.dart';
import 'package:wakatime_api/models/heartbeat.dart';

void main() {
  test('Deserialize heartbeat', () {
    final json = {
      "branch": "dev",
      "category": "coding",
      "created_at": "2022-02-04T08:12:40Z",
      "cursorpos": 31,
      "dependencies": [],
      "entity": "/Users/smaso/Development/toduba2/pubspec.yaml",
      "id": "3fd034d0-b3db-451b-8c96-00b1f5d3a6b8",
      "is_write": null,
      "language": "YAML",
      "lineno": 39,
      "lines": 147,
      "machine_name_id": "da633e09-f362-4b0f-838a-0686e9cae901",
      "project": "toduba2",
      "time": 1643962358.490708,
      "type": "file",
      "user_agent_id": "16fc1bdd-6e3a-4363-9107-32480240a337",
      "user_id": "6de661cc-aaf6-48d1-b19c-3b8aa8990b73"
    };

    final hb = Heartbeat.fromJson(json);
    expect(hb.branch, 'dev');
    expect(hb.category, 'coding');
    expect(hb.createdAt, '2022-02-04T08:12:40Z');
    expect(hb.cursorpos, 31);
    expect(hb.dependencies, []);
    expect(hb.entity, '/Users/smaso/Development/toduba2/pubspec.yaml');
    expect(hb.id, '3fd034d0-b3db-451b-8c96-00b1f5d3a6b8');
    expect(hb.isWrite, null);
    expect(hb.language, 'YAML');
    expect(hb.lineno, 39);
    expect(hb.lines, 147);
    expect(hb.machineNameId, 'da633e09-f362-4b0f-838a-0686e9cae901');
    expect(hb.project, 'toduba2');
    expect(hb.time, 1643962358.490708);
    expect(hb.type, 'file');
    expect(hb.userAgentId, '16fc1bdd-6e3a-4363-9107-32480240a337');
    expect(hb.userId, '6de661cc-aaf6-48d1-b19c-3b8aa8990b73');
  });
}
